<?php
/**
 * @package Sj Vm Slideshow II
 * @version 2.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

class VmSlideShowiiReader extends SjReader{
	protected $_categories = null;

	public function getList(&$params){
		//YTools::dump($params);
		$user	= &JFactory::getUser();
		$app	= &JFactory::getApplication();
		$db		= &JFactory::getDBO();
		
		$lang_params = &JComponentHelper::getParams('com_languages');
		$lang = $lang_params->get('site', 'en-GB'); //use default joomla
		$lang = strtolower(strtr($lang,'-','_'));
		
		$arrcustom_url = $this->getCustomData($params['custom_url']);
		//var_dump($params['source_limit']); die("anc");
		// category filter
		$all_category_flag = false;
		if (!isset($params['source']) || $params['source']==''){
			// all categories
			$all_category_flag = true;
		} else if (!is_array($params['source'])){
			if ((int)$params['source']){
				$params['source'] = array($params['source']);
			} else {
				$all_category_flag = true;
			}
		}
			
		if (isset($params['subcategories']) && (int)$params['subcategories']){
			// init categories list
			$include_subcategories = true;
			// $this->_getCategories();
		} else {
			$include_subcategories = false;
		}
			
		$category_filter = "";
		if ($all_category_flag){
			$category_filter = "";
		} else {
			if ($include_subcategories){
				$all_category = array();
				foreach ($params['source'] as $cid){
					$tmp = $this->getChildOf($cid, true);
					$all_category = array_merge($all_category, $tmp);
				}
				array_unique($all_category);
				$category_filter = "AND pcx.virtuemart_category_id IN (" . implode(',', $all_category) . ")";;
			} else {
				$category_filter = "AND pcx.virtuemart_category_id IN (" . implode(',', $params['source']) . ")";;
			}
		}
		//var_dump($all_category); die("abc");
		// special filter
		$source_filter = "";
		if (isset($params['source_filter']) && (int)$params['source_filter']){
			switch((int)$params['source_filter']){
				case 1:
					$source_filter = "AND p2.product_special=0";
					break;
				case 2:
					$source_filter = "AND p2.product_special=1";
					break;
			}
		}
			
		// source order by
		$source_order_by = "";
		if (isset($params['source_order_by'])){
			switch ($params['source_order_by']){
				default:
				case 'ordering':
					$source_order_by = "ORDER BY p2.product_sku";
				break;
				case 'bestsales':
					$source_order_by = "ORDER BY p2.product_sales DESC";
					break;
				case 'reviews':
					$source_order_by = "ORDER BY reviews DESC";
					break;
				case 'pricedes':
					$source_order_by = "ORDER BY price.product_price DESC";
					break;
				case 'priceasc':
					$source_order_by = "ORDER BY price.product_price";
					break;
				case 'created':
					$source_order_by = "ORDER BY p2.created_on DESC";
					break;
				case 'modified':
					$source_order_by = "ORDER BY p2.modified_on DESC";
					break;
				case 'title':
					$source_order_by = "ORDER BY p1.product_name";
					break;
				case 'random':
					$source_order_by = "ORDER BY rand()";
					break;
			}
		}
		$source_limit = "";
		if (isset($params['source_limit']) && (int)$params['source_limit']){
			$source_limit_start = 0;
			if (isset($params['source_limit_start']) && (int)$params['source_limit_start']){
				$source_limit_start = (int)$params['source_limit_start'];
			}
			$source_limit_total = (int)$params['source_limit'];
			$source_limit = "LIMIT $source_limit_start, $source_limit_total";
		}
		 
		$query = "
				SELECT
					p1.virtuemart_product_id AS id,
					p1.product_name AS title,
					p1.product_s_desc AS description,
					p1.slug AS slug,
					p2.product_sku AS sku,
					p2.product_in_stock,
					p2.product_ordered,
					p2.product_sales,
					price.virtuemart_product_price_id,
                    price.product_price,
					(
						SELECT m.file_url
						FROM #__virtuemart_medias m
						INNER JOIN #__virtuemart_product_medias pm ON pm.virtuemart_media_id=m.virtuemart_media_id
						WHERE pm.virtuemart_product_id=p2.virtuemart_product_id AND m.published=1
						ORDER BY pm.ordering
						LIMIT 0, 1
					) AS image,
					(SELECT COUNT(pr.virtuemart_rating_review_id) FROM #__virtuemart_rating_reviews pr WHERE pr.virtuemart_product_id=p2.virtuemart_product_id AND pr.published=1) AS reviews,
					GROUP_CONCAT(pcx.virtuemart_category_id) AS categories
				FROM #__virtuemart_products_$lang AS p1
					JOIN #__virtuemart_products AS p2 USING (virtuemart_product_id)
					LEFT JOIN #__virtuemart_product_prices AS price ON price.virtuemart_product_id=p1.virtuemart_product_id
					JOIN #__virtuemart_product_categories AS pcx ON pcx.virtuemart_product_id=p1.virtuemart_product_id
			  	WHERE
			  		p2.published=1
					$category_filter
					$source_filter
			  	GROUP BY p2.virtuemart_product_id
				$source_order_by
				$source_limit
			";
		// YTools::dump(str_replace('#__', 'jos_', $query));
			
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		//var_dump($count); die("abc");
			
		// return data
		$items = array();
		if(!empty($rows)){
			if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'config.php');
			VmConfig::loadConfig();
			if (!class_exists( 'calculationHelper' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'calculationh.php');
			if (!class_exists( 'CurrencyDisplay' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'currencydisplay.php');
			$vmconfig_show_prices = VmConfig::get('show_prices');//var_dump($vmconfig_show_prices); die("cbcbcb");
			$calculator = calculationHelper::getInstance();
			$currency = CurrencyDisplay::getInstance();

			if (count($rows)){
				foreach($rows as $product){

					if(array_key_exists($product->id, $arrcustom_url)){
						$product->link = $arrcustom_url[$product->id];
					} else {
						$product->link = JRoute::_( 'index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$product->id.'&virtuemart_category_id='.$product->categories);
					}//var_dump($product->link); die("abc");
					
					if (!$product->image || !file_exists($product->image)){
						$product->image = 'modules/' . YTools::getModule()->module . '/assets/images/nophoto.gif';
					}
					
					$calculator = calculationHelper::getInstance();
					$product->prices = $calculator->getProductPrices($product->id);

				}
				foreach($rows as $key => $product){
					$vm = array();
					$vm['title'] = $product->title;
					$vm['image'] = $product->image;
					$vm['link']  = $product->link;
					$vm['price'] = $product->prices;
					if($params['desc_keep_html'] == 0){
						$vm['desc']  = strip_tags($product->description);
					}else{
						$vm['desc']  = $product->description;
					}
					$items[] = $vm;
				}
			}
			return $items;
		}
	}

	public function _getCategories(){
		if (is_null($this->_categories)){
			$lang_params = &JComponentHelper::getParams('com_languages');
			$lang = $lang_params->get('site', 'en-GB'); //use default joomla
			$lang = strtolower(strtr($lang,'-','_'));
			
			$db = &JFactory::getDBO();
			$query = "
					SELECT
						c.virtuemart_category_id AS id,
						vmlang.category_name AS title,
						vmlang.slug AS slug,
						cx.category_parent_id AS parent
					FROM #__virtuemart_categories_$lang AS vmlang
						JOIN #__virtuemart_categories AS c USING (virtuemart_category_id)
						LEFT JOIN #__virtuemart_category_categories AS cx ON cx.category_child_id=vmlang.virtuemart_category_id
					WHERE c.published=1
					ORDER BY c.ordering
				";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			$list = array();
			if (count($rows)>0){
				// mark by category id
				foreach ($rows as $i => $cat) {
					$cat->level = 1;
					$list[$cat->id] = &$rows[$i];
					//YTools::dump($cat, "$i:");
				}
				// build child list for parent category.
				foreach ($list as $cid => $category) {
					if (isset($list[$category->parent])){
						$parent_category = &$list[$category->parent];
						if (!isset($parent_category->child_category)){
							$parent_category->child_category = array();
						}
						$parent_category->child_category[$cid] = &$list[$cid];
					}
				}
			}
			$this->_categories = $list;
		}
		return $this->_categories;
	}

	public function getCategoryById($cid=array()){
		$categories = &$this->_getCategories();
		if (!is_array($cid)){
			if (isset($categories[$cid])){
				$category = &$categories[$cid];
			} else {
				$category = null;
			}
			return $category;
		} else if (count($cid) > 0){
			$category = array();
			foreach ($cid as $id){
				if (isset($categories[$id])){
					$category[$id] = &$categories[$id];
				}
			}
			return $category;
		}
		return $categories;
	}

	public function getChildOf($ids=array(), $self_included=false, $deep=0){
		$return = array();
		if (!is_array($ids)){
			$ids = array($ids);
		}
		$categories = &$this->_getCategories();
		foreach ($ids as $cid) {
			if (isset($categories[$cid])){
				if ($deep>0){
					$categories[$cid]->level = 1;
				}
				$stack = array($categories[$cid]);
				while( count($stack)>0 ){
					$top = array_pop($stack);
					if ($self_included || $cid != $top->id){
						in_array($top->id, $return) || array_push($return, $top->id);
					}
					if (isset($top->child_category)){
						foreach (array_reverse($top->child_category) as $child){
							if ($deep>0 && ($top->level+1>$deep)){
								continue;
							} else if ($deep>0) {
								$child->level = $top->level + 1;
							}
							array_push($stack, $child);
						}
					}
				}
			}
		}
		return $return;
	}

	private function _getRootParentOf($category_id, $category_map){
		$return = array();
		foreach ($category_map as $rid => $cids) {
			if (in_array($category_id, $cids)){
				array_push($return, $rid);
			}
		}
		return count($return);
	}

	private function getCustomData($custom_url) {
		$data_array = array();
		$tmp = explode("\n", trim($custom_url));
		foreach( $tmp as $strTmp){
			$pos = strpos($strTmp, ":");
			if($pos >=0){
				$tmpKey = substr($strTmp, 0, $pos);
				$key = trim($tmpKey);
				$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
				$haveHttp =  strpos(trim($tmpLink), "http://");
				//var_dump($haveHttp);die;
				if($haveHttp<0 || ($haveHttp !== false) ){
					$link = trim($tmpLink);
				}else{
					$link = "http://" . trim($tmpLink);
				}
				$data_array[$key] = $link;
			}
		}
		return $data_array;
	}
}
