<?php
/*------------------------------------------------------------------------
 # Yt Vm Slideshow II- Version 1.0
 # Copyright (C) 2011 YouTech Company. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Company
 # Websites: http://www.smartaddons.com/
 -------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (class_exists('JFormField')){
	class JFormFieldListVmCategory extends JFormField {
		var   $_name = 'Yt Category Listing';
		function getInput(){
			$options = array();
			$db =& JFactory::getDBO();
			
			$category_query = "
				SELECT c.virtuemart_category_id AS id, c.category_name AS title, cc.category_parent_id AS parent
				FROM #__virtuemart_categories AS c
				LEFT JOIN #__virtuemart_category_categories AS cc ON cc.category_child_id=c.virtuemart_category_id
				ORDER BY c.ordering
			";
			
			$db->setQuery($category_query);
			$categories = $db->loadObjectList();
			
			$list = array();
			$root = new stdClass();
			$root->id = 0;
			$root->title = JText::_('All Categories');
			$root->parent = -1;
			$list[0] = $root;
			
			// render category tree for selection
			foreach ($categories as $c) {
				$list[$c->id] = $c;
			}
			
			foreach ($list as $cid => $c){
				if (isset($list[$c->parent])){
					if (!isset($list[$c->parent]->child)){
						$list[$c->parent]->child = array();
					}
					$list[$c->parent]->child[] =& $list[$cid];
				}
			}
			foreach($list as $cid => $c){
				if (!isset($list[$c->parent])){
					$list[$cid]->level=1;
					$stack = array($list[$cid]);
					while( count($stack)>0 ){
						$opt = array_pop($stack);
						$option = array(
					    	'label' => ($opt->level>1 ? str_repeat('- - ', $opt->level-1) : '') . $opt->title,
					    	'value' => $opt->id
						);
						array_push($options, $option);
						if (isset($opt->child) && count($opt->child)){
							foreach($opt->child as $child){
								$child->level = $opt->level + 1;
								array_push($stack, $child);
							}
						}
					}
				}
			}

			$html = "";
			if (count($options)>0){
				if (!is_array($this->value)){
					$this->value = array($this->value);
				}
				$size = min(count($options), 14) + 1;
				$html = '<select class="inputbox" multiple="multiple" size="' . $size . '" style="min-width: 200px;" id="' . $this->id . '" name="' . $this->name . '[]">';
				foreach ($options as $opt){
					$selected = in_array($opt['value'], $this->value) ? 'selected="selected"' : '';
					$html .= '<option value="' . $opt['value'] . '" ' . $selected . '>' . $opt['label'] . '</option>';
				}
				$html .= '<select>';
			} else {
				$html = JText::_('Has no categories');
			}
			return $html;
		}
	}
}