<?php
/*------------------------------------------------------------------------
 # Yt Vm Slideshow II- Version 1.0
 # Copyright (C) 2011 YouTech Company. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Company
 # Websites: http://www.smartaddons.com/
 -------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!class_exists('YtSlideShowII')){
	class YtSlideShowII {
		private $options;
		private $data = null;
		private $reader = null;

		function __construct($options=array()){
			$this->options = (object)array_merge( $this->_getOptions(), $options );
		}

		private function _loadData($module){
			if (!isset($this->data)){
				$this->data = $this->_getReader()->getList($this->options, $module);
			}
		}

		private function _getReader(){
			if (!isset($this->reader)){
				$class = get_class($this);
				if (!empty($this->options->reader)){
					$class .= $this->options->reader;
				} else {
					$class .= 'Reader';
				}
				$filename = dirname(__FILE__) . DS . strtolower($class) . '.php';
				if (file_exists($filename)){
					include $filename;
					$reader = new $class();
					if (!method_exists($reader, 'getList')){
						throw new Exception("function $class-\>getList has not implement yet.");
					}
					return $reader;
				} else {
					throw new Exception("File not found: " . $filename);
				}
			}
			return $this->reader;
		}

		private function _getOptions(){
			return array(
				'moduleclass_sfx' => '',
                'width_module' => 700,			
				'theme' => 'theme1',
				'source' => array(),
				'source_order_by' => 'created',
				'source_filter' => 0,
				'limit_items' => 5,
				'limit_title' => 25,
				'limit_desc'=> 100,
                'show_normal_desc'=> 1,
                'limit_normal_desc'=> 80,
                'opacity_main' => 0.7,
                'normal_background'=>'#FFFFFF',
                'normal_active_background'=>'#2c0da0',
				'show_image'=>1,
                'show_normal_image'=>1,
				'link_image' =>1,
				'link_title'=>1,
				'play' => 1,
				'show_title' =>1,
                'show_normal_title'=>1,
				'show_desc' =>1,
				'target'=> '_self',
				'thumb_width' => '450',
				'thumb_height'=> '350',
                'small_thumb_width' => '70',
                'small_thumb_height'=> '55',
				'thumbnail_background' => '#ffffff',
				'thumbnail_mode'=> 'stretch',				
				'bgOpacity'=> '#0F0909',
				'bgContent'=>'#F8F8F8',
				'title_color'=> '#545454',
                'title_active_color'=> '#FFFFFF',
				'desc_color'=>'#FFFFFF',
                'normal_desc_color'=> '#FFFFFF',
                'normal_desc_active_color'=>'#FFFFFF',
				'show_price' => 1,
                'show_base_price' => 1,                
				'price_color' => '#545454',
                'active_price_color' =>'#FFFFFF',
				'show_buttons'=> 1,
				'desc_keep_html'=>1,
				'slideshow_speed' => 2000,
				'timer_speed'=> 4000,
				'effect'=> 'horizotal',
				'show_read_more' => 1,
				'read_more_text'=> 'read more..',
				'show_intro' => 1,
				'show_footer' => 1,
				'customUrl'=> '',
				'intro_text' => '',
				'footer_text' => '',
				'subcategories' => 1,
				'num_item_per_page' => 4,
                'show_img_on_right'=> 1
			);
		}
		public function getOption($key=null, $default=null){
			if (null==$key){
				return $this->options;
			} else {
				if (isset($this->options[$key])){
					return $this->options[$key];
				} else {
					return $default;
				}
			}
			return $value;
		}
		public function getData($module){
			isset($this->data) or $this->_loadData($module);
			return $this->data;
		}
	}
}
