<?php
/*------------------------------------------------------------------------
 # Yt Vm Slideshow II- Version 1.0
 # Copyright (C) 2011 YouTech Company. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Company
 # Websites: http://www.smartaddons.com/
 -------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!class_exists('YtSlideShowIIVmReader')){
	class YtSlideShowIIVmReader{
		public function __construct(){
			class_exists('YtUtils') or include_once 'ytutils.php';
			class_exists('Yt_VmSlideII_Helper') or include_once 'ytvmhelper.php';
		
			
			if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'config.php');
			VmConfig::loadConfig();
			if (!class_exists( 'calculationHelper' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'calculationh.php');
			if (!class_exists( 'CurrencyDisplay' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'currencydisplay.php');	
		}
		public function getList(&$options, $module){
			$list 		= array();
			
			$user 		=&	JFactory::getUser();
			$app 		=&	JFactory::getApplication();
			$db   		=&	JFactory::getDBO();
			$jnow		=& 	JFactory::getDate();
			$now		= 	$jnow->toMySQL();
			$nullDate	=	$db->getNullDate();
			$noauth		= !	$app->getParams()->get('show_noauth');
			$arrCustomUrl = array();
			$source 	= $options->source;			
			$items = array();
			$category = array();
			//get string of differebt category ids
			$cate_ids = '';
			$array_catids = array();			
			$where_catids = "";
			
			//update price
            $vmconfig_show_prices = VmConfig::get('show_prices');
			$calculator = calculationHelper::getInstance();	
			$currency = CurrencyDisplay::getInstance();
			
			
			if(isset($source) && !empty($source)){
               if($source[0] != '0'){
                   if($options->subcategories == 1){
                      foreach($source as $key=>$value){ 
                        $temp = array();
                        $temp = Yt_VmSlideII_Helper::getSubCategories($value,true);
                        $array_catids = array_merge($array_catids, $temp);
                        $array_catids = array_unique($array_catids);
                    
                      }    
                    }else{
                        $array_catids = $source;                     
                    }        
                        
                    $where_catids = " AND c.virtuemart_category_id IN (" . implode("," , $array_catids) . ")";
                    
               }elseif((count($source)>1) && ($source[0] == 0)){   
                    unset($source[0]);
                    $array_catids = $source;              
                    $where_catids = " AND c.virtuemart_category_id IN (" . implode("," , $array_catids) . ")";        
              }
            }
			//var_dump($where_catids); die('5353535');		
			
			// Special filter.
			if ( isset($options->source_filter) ){
				
				switch ($options->source_filter){
					default:
					case '0':
						$source_filter = "";
						break;
					case '1':
						$source_filter = " AND a.product_special= '0'";
						break;
					case '2':
						$source_filter = " AND a.product_special= '1'";
						break;
				}
			}
			
			if ( isset($options->source_order_by) ){
				switch ($options->source_order_by){
					case 'hits':
						$order_by = " ORDER BY a.product_sales DESC";
						break;
					case 'reviews':
						$order_by = " ORDER BY comments DESC";
						break;
					case 'pricedes':
						$order_by = " ORDER BY product_price DESC";
						break;
					case 'priceasc':
						$order_by = " ORDER BY product_price ASC";
						break;					
					case 'modified':
						$order_by = " ORDER BY a.modified_on DESC";
						break;
					case 'title':
						$order_by = " ORDER BY a.product_name ASC";
						break;
					case 'random':
						$order_by = " ORDER BY rand()";
						break;
					case 'created':
					default:
						$order_by = " ORDER BY a.created_on DESC";
						break;
				}
			}
			
			$query =
				"
				SELECT
					a.virtuemart_product_id	AS id,
					a.product_name 			AS title,
					a.modified_on 			AS modified,
					a.created_on 			AS created,
					a.product_s_desc 		AS description,
					a.product_sales 		AS hits,
					a.product_url			AS product_url,
					
					DATEDIFF(NOW(), a.created_on) AS datediff,
					
					(
						SELECT GROUP_CONCAT(m.file_url SEPARATOR ',')
						FROM #__virtuemart_medias m
						INNER JOIN #__virtuemart_product_medias pm ON pm.virtuemart_media_id=m.virtuemart_media_id
						WHERE pm.virtuemart_product_id=a.virtuemart_product_id AND m.published=1 AND m.file_type='product'
						ORDER BY pm.ordering
					) AS image_urls,
					
					(
						SELECT COUNT(pr.virtuemart_rating_review_id) FROM #__virtuemart_rating_reviews pr WHERE pr.virtuemart_product_id=a.virtuemart_product_id AND pr.published=1
					) AS comments,
					
					(
						SELECT GROUP_CONCAT(c.virtuemart_category_id SEPARATOR ',')
						FROM #__virtuemart_product_categories c
						WHERE c.virtuemart_product_id=a.virtuemart_product_id $where_catids
						ORDER BY c.ordering
					) as cats,
					
					pc.product_price,
					pc.currency_symbol as currency_code,
					pc.currency_decimal_place,
					pc.currency_positive_style
					
				FROM #__virtuemart_products a
				LEFT JOIN (
						SELECT p.virtuemart_product_id, p.virtuemart_shoppergroup_id, p.product_price, cr.currency_symbol, cr.currency_decimal_place, cr.currency_positive_style
						FROM #__virtuemart_product_prices p						
						LEFT JOIN #__virtuemart_currencies cr ON cr.virtuemart_currency_id=p.product_currency
						WHERE cr.published=1
					) as pc ON pc.virtuemart_product_id=a.virtuemart_product_id
				WHERE
					a.published=1
					$source_filter
                GROUP BY a.virtuemart_product_id
				HAVING cats IS NOT NULL
				";
			
			$query .= $order_by;			
			$query .=  $options->limit_items ? ' LIMIT ' . $options->limit_items : '';	
			$db->setQuery($query);
			$items = $db->loadObjectList();

	//	var_dump($items); die('355353');
			
			
			$imgResizeConfig = array(
				'background' => $options->thumbnail_background,
				'thumbnail_mode' => $options->thumbnail_mode
			);
			YtUtils::getImageResizerHelper($imgResizeConfig);
			
			$arrCustomUrl = Yt_VmSlideII_Helper::getArrURL($options->customUrl); 
			
			
			if(!empty($items)){
			
				foreach ($items as $key=>$item){
				    $item->full_title = $item->title;
					$item->title = YtUtils::shorten($item->title, $options->limit_title);
					
					if(array_key_exists($item->id, $arrCustomUrl)){					
						$item->link = $arrCustomUrl[$item->id];     
					} else {
						$item->link = JRoute::_( 'index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$item->id.'&virtuemart_category_id='.$item->cats);  			
					}
					
					$item->image_urls = explode(',', $item->image_urls);
					
					if ( count($item->image_urls) <= 0 ){                       
                        $item->image = 'modules/'.$module->module.'/assets/images/no_image.gif';
						$item->small_image = 'modules/'.$module->module.'/assets/images/no_image.gif';
                        
                    } else {
                        $image_url = array_shift($item->image_urls);                   
                        
                        if(file_exists($image_url) && (!empty($image_url))){
                             $item->image = $image_url;
							 $item->small_image = $image_url;
                        }else{  
                             $item->image = 'modules/'.$module->module.'/assets/images/no_image.gif';
							 $item->small_image = 'modules/'.$module->module.'/assets/images/no_image.gif';
							 
                        }
                   
                        if ('none' != $options->thumbnail_mode && $item->image){
                            $imagefile = JPath::find(JPATH_SITE, $item->image);
                            $item->image = YtUtils::resize($imagefile, $options->thumb_width, $options->thumb_height, $options->thumbnail_mode);
                          
                        }
					    if ('none' != $options->thumbnail_mode && $item->small_image){
                            $imagefile = JPath::find(JPATH_SITE, $item->small_image);
                            $item->small_image = YtUtils::resize($imagefile, $options->small_thumb_width, $options->small_thumb_height, $options->thumbnail_mode);
                       
                        }
                    }
                    
					$item->desc = YtUtils::shorten($item->description, $options->limit_desc);
					if ($options->desc_keep_html == 0){
						$item->desc = strip_tags($item->desc);
					}

                    $item->normal_desc = YtUtils::shorten($item->description, $options->limit_normal_desc);
                    if ($options->desc_keep_html == 0){
                        $item->normal_desc = strip_tags($item->normal_desc);
                    }
                    
                    
                    
					switch ($item->datediff){
						case 0:
							$item->createdfrom = YtUtils::getDateAgo($item->created);
							break;
						default:
							$item->createdfrom = JHTML::_('date', $item->created, JText::_('DATE_FORMAT'));
					}
					
				 
				   // price of product
                   if(isset($item->product_price)){
                      if ($vmconfig_show_prices == 1){
                          
                              $variantPriceModification = $calculator->calculateModificators($item->id, array());
                              $prices = $calculator->getProductPrices($item->id, $item->cats, $variantPriceModification, 1);    
                                        
                              if(isset($prices['basePriceWithTax']) && ($prices['basePriceWithTax'] > 0)){
                                     $item->base_price_tax = $currency->priceDisplay($prices['basePriceWithTax']);  
                              }else{                                  
                                     $item->base_price_tax = $currency->priceDisplay($prices['basePrice']);                                    
                              }                      
                              
                               if ($prices['salesPriceWithDiscount']>0) {
                                  if($options->show_base_price == 1){
                                       $item->price =  JText::_('PRICE') . "<s>". $item->base_price_tax."</s>"." ". $currency->priceDisplay($prices['salesPriceWithDiscount']);                                     
                                  }else{
                                       $item->price =  JText::_('PRICE') . $currency->priceDisplay($prices['salesPriceWithDiscount']);
                                      
                                  }
                              }else{       
                                  if($options->show_base_price == 1){ 
                                       $item->price =  JText::_('PRICE') . "<s>". $item->base_price_tax."</s>"." ". $currency->priceDisplay($prices['salesPrice']);   
                                  }else{
                                       $item->price =  JText::_('PRICE') . $currency->priceDisplay($prices['salesPrice']);
                                      
                                  }          
                                   
                              }         
                      }else{
                          
                             $call_4pricing_url = JRoute::_("index.php?option=com_virtuemart&view=productdetails&task=askquestion&virtuemart_product_id=". $item->id ."&virtuemart_category_id=".$item->cats);
                          
                             $item->price ="<a href=\"$call_4pricing_url\">" . JText::_('CALL_FOR_PRICING') . "</a>";          
                      }
                  }else{                      
                             $item->price = JText::_('NO PRICE');                      
                  }
                      $category[$key]['id'] = $item->id;
					  $category[$key]['full_title'] = $item->full_title;
					  $category[$key]['title'] = $item->title;
					  $category[$key]['link'] = $item->link;
					  $category[$key]['image'] = $item->image;
                      $category[$key]['small_image'] = $item->small_image;
					  $category[$key]['desc'] = $item->desc;
                      $category[$key]['normal_desc'] =  $item->normal_desc;                     
					  $category[$key]['createdfrom'] = $item->createdfrom;
					  $category[$key]['price'] =  $item->price;
					  
				}			
			 }
				//var_dump($category); die('66666');		
			return $category;
		}
	}
}